"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Badge = void 0;
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var helpers_1 = require("../helpers");
var Badge = function (_a) {
    var _b;
    var containerStyle = _a.containerStyle, textStyle = _a.textStyle, textProps = _a.textProps, badgeStyle = _a.badgeStyle, onPress = _a.onPress, onLongPress = _a.onLongPress, onPressOut = _a.onPressOut, onPressIn = _a.onPressIn, _c = _a.Component, Component = _c === void 0 ? onPress || onLongPress || onPressIn || onPressOut
        ? react_native_1.Pressable
        : react_native_1.View : _c, value = _a.value, _d = _a.theme, theme = _d === void 0 ? helpers_1.defaultTheme : _d, _e = _a.status, status = _e === void 0 ? 'primary' : _e, pressableProps = _a.pressableProps, rest = __rest(_a, ["containerStyle", "textStyle", "textProps", "badgeStyle", "onPress", "onLongPress", "onPressOut", "onPressIn", "Component", "value", "theme", "status", "pressableProps"]);
    var element = (0, helpers_1.renderNode)(react_native_1.Text, value, __assign({ style: react_native_1.StyleSheet.flatten([styles.text, textStyle && textStyle]) }, textProps));
    return (react_1.default.createElement(react_native_1.View, { testID: "RNE__Badge__Container", style: react_native_1.StyleSheet.flatten([containerStyle && containerStyle]) },
        react_1.default.createElement(Component, __assign({}, __assign(__assign({ onPress: onPress, onLongPress: onLongPress, onPressOut: onPressOut, onPressIn: onPressIn }, pressableProps), rest), { testID: "RNE__Badge", style: react_native_1.StyleSheet.flatten([
                {
                    alignSelf: 'center',
                    minWidth: size,
                    height: size,
                    borderRadius: size / 2,
                    alignItems: 'center',
                    justifyContent: 'center',
                    backgroundColor: (_b = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _b === void 0 ? void 0 : _b[status],
                    borderWidth: react_native_1.StyleSheet.hairlineWidth,
                    borderColor: '#fff',
                },
                !element && styles.miniBadge,
                badgeStyle && badgeStyle,
            ]) }), element)));
};
exports.Badge = Badge;
var size = 18;
var miniSize = 8;
var styles = react_native_1.StyleSheet.create({
    miniBadge: {
        paddingHorizontal: 0,
        paddingVertical: 0,
        minWidth: miniSize,
        height: miniSize,
        borderRadius: miniSize / 2,
    },
    text: {
        fontSize: 12,
        color: 'white',
        paddingHorizontal: 4,
    },
});
exports.Badge.displayName = 'Badge';
