"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withBadge = void 0;
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var Badge_1 = require("./Badge");
var withBadge = function (value, options) {
    if (options === void 0) { options = {}; }
    return function (WrappedComponent) {
        var WithBadge = function (props) {
            var bottom = options.bottom, _a = options.hidden, hidden = _a === void 0 ? false : _a, left = options.left, containerStyle = options.containerStyle, badgeProps = __rest(options, ["bottom", "hidden", "left", "containerStyle"]);
            var _b = options.right, right = _b === void 0 ? -16 : _b, _c = options.top, top = _c === void 0 ? -1 : _c;
            if (!value) {
                right = -3;
                top = 3;
            }
            var badgeValue = typeof value === 'function' ? value(props) : value;
            return (react_1.default.createElement(react_native_1.View, { style: react_native_1.StyleSheet.flatten([styles.container, containerStyle]) },
                react_1.default.createElement(WrappedComponent, __assign({}, props)),
                !hidden && (react_1.default.createElement(Badge_1.Badge, __assign({ value: badgeValue, status: "error", containerStyle: react_native_1.StyleSheet.flatten([
                        styles.badgeContainer,
                        { bottom: bottom, left: left, right: right, top: top },
                    ]) }, badgeProps)))));
        };
        WithBadge.displayName = "WithBadge(".concat(WrappedComponent.displayName || WrappedComponent.name || 'Component', ")");
        return WithBadge;
    };
};
exports.withBadge = withBadge;
var styles = react_native_1.StyleSheet.create({
    badgeContainer: {
        position: 'absolute',
    },
    container: {
        alignItems: 'center',
        justifyContent: 'center',
        position: 'relative',
    },
});
