"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ButtonGroup = void 0;
var color_1 = __importDefault(require("color"));
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var helpers_1 = require("../helpers");
var Text_1 = require("../Text");
var ButtonGroup = function (_a) {
    var _b, _c;
    var _d = _a.Component, Component = _d === void 0 ? react_native_1.Pressable : _d, pressableProps = _a.pressableProps, buttons = _a.buttons, _e = _a.onPress, onPress = _e === void 0 ? function () { return null; } : _e, onLongPress = _a.onLongPress, onPressIn = _a.onPressIn, onPressOut = _a.onPressOut, _f = _a.selectedIndex, selectedIndex = _f === void 0 ? null : _f, _g = _a.selectedIndexes, selectedIndexes = _g === void 0 ? [] : _g, _h = _a.selectMultiple, selectMultiple = _h === void 0 ? false : _h, containerStyle = _a.containerStyle, innerBorderStyle = _a.innerBorderStyle, buttonStyle = _a.buttonStyle, buttonContainerStyle = _a.buttonContainerStyle, textStyle = _a.textStyle, selectedTextStyle = _a.selectedTextStyle, selectedButtonStyle = _a.selectedButtonStyle, activeOpacity = _a.activeOpacity, onHideUnderlay = _a.onHideUnderlay, onShowUnderlay = _a.onShowUnderlay, setOpacityTo = _a.setOpacityTo, _j = _a.disabled, disabled = _j === void 0 ? false : _j, disabledStyle = _a.disabledStyle, disabledTextStyle = _a.disabledTextStyle, disabledSelectedStyle = _a.disabledSelectedStyle, disabledSelectedTextStyle = _a.disabledSelectedTextStyle, _k = _a.vertical, vertical = _k === void 0 ? false : _k, _l = _a.theme, theme = _l === void 0 ? helpers_1.defaultTheme : _l, _m = _a.underlayColor, underlayColor = _m === void 0 ? (_b = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _b === void 0 ? void 0 : _b.primary : _m, rest = __rest(_a, ["Component", "pressableProps", "buttons", "onPress", "onLongPress", "onPressIn", "onPressOut", "selectedIndex", "selectedIndexes", "selectMultiple", "containerStyle", "innerBorderStyle", "buttonStyle", "buttonContainerStyle", "textStyle", "selectedTextStyle", "selectedButtonStyle", "activeOpacity", "onHideUnderlay", "onShowUnderlay", "setOpacityTo", "disabled", "disabledStyle", "disabledTextStyle", "disabledSelectedStyle", "disabledSelectedTextStyle", "vertical", "theme", "underlayColor"]);
    var innerBorderWidth = (_c = innerBorderStyle === null || innerBorderStyle === void 0 ? void 0 : innerBorderStyle.width) !== null && _c !== void 0 ? _c : 1;
    return (react_1.default.createElement(react_native_1.View, __assign({ testID: "RNE__ButtonGroupContainer" }, rest, { style: react_native_1.StyleSheet.flatten([
            styles.container,
            vertical && styles.verticalContainer,
            containerStyle && containerStyle,
        ]) }), buttons === null || buttons === void 0 ? void 0 : buttons.map(function (button, i) {
        var _a, _b, _c, _d, _e, _f;
        var isSelected = selectedIndex === i || selectedIndexes.includes(i);
        var isDisabled = disabled === true ||
            (Array.isArray(disabled) && disabled.includes(i));
        return (react_1.default.createElement(react_native_1.View, { key: i, style: react_native_1.StyleSheet.flatten([
                !vertical && styles.button,
                vertical && styles.verticalComponent,
                i !== buttons.length - 1 &&
                    (vertical
                        ? {
                            borderBottomWidth: innerBorderWidth,
                            borderBottomColor: (innerBorderStyle && innerBorderStyle.color) ||
                                ((_a = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _a === void 0 ? void 0 : _a.grey4),
                        }
                        : {
                            borderRightWidth: innerBorderWidth,
                            borderRightColor: (innerBorderStyle && innerBorderStyle.color) ||
                                ((_b = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _b === void 0 ? void 0 : _b.grey4),
                        }),
                buttonContainerStyle,
            ]) },
            react_1.default.createElement(Component, __assign({ testID: "RNE__ButtonGroupItem", accessibilityState: {
                    disabled: isDisabled,
                }, activeOpacity: activeOpacity, setOpacityTo: setOpacityTo, onHideUnderlay: onHideUnderlay, onShowUnderlay: onShowUnderlay, disabled: isDisabled, onPress: function () {
                    if (selectMultiple) {
                        if (selectedIndexes.includes(i)) {
                            onPress(selectedIndexes.filter(function (index) { return index !== i; }));
                        }
                        else {
                            onPress(__spreadArray(__spreadArray([], selectedIndexes, true), [i], false));
                        }
                    }
                    else {
                        onPress(i);
                    }
                }, style: styles.button }, __assign({ android_ripple: (0, helpers_1.androidRipple)((0, color_1.default)(underlayColor).alpha(activeOpacity).rgb().toString()), onPressIn: onPressIn, onPressOut: onPressOut, onLongPress: onLongPress }, pressableProps)),
                react_1.default.createElement(react_native_1.View, { style: react_native_1.StyleSheet.flatten([
                        styles.textContainer,
                        buttonStyle && buttonStyle,
                        isSelected && {
                            backgroundColor: (_c = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _c === void 0 ? void 0 : _c.primary,
                        },
                        isSelected && selectedButtonStyle && selectedButtonStyle,
                        isDisabled && styles.disabled,
                        isDisabled && disabledStyle,
                        isDisabled &&
                            isSelected && {
                            backgroundColor: (_d = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _d === void 0 ? void 0 : _d.disabled,
                        },
                        isDisabled && isSelected && disabledSelectedStyle,
                    ]) }, hasElementKey(button) ? (react_1.default.createElement(button.element, { isSelected: isSelected })) : (react_1.default.createElement(Text_1.Text, { testID: "buttonGroupItemText", style: react_native_1.StyleSheet.flatten([
                        __assign({ fontSize: (0, helpers_1.normalizeText)(13), color: (_e = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _e === void 0 ? void 0 : _e.grey2 }, react_native_1.Platform.select({
                            android: {},
                            default: {
                                fontWeight: '500',
                            },
                        })),
                        textStyle && textStyle,
                        isSelected && { color: '#fff' },
                        isSelected && selectedTextStyle,
                        isDisabled && {
                            color: (0, helpers_1.color)((_f = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _f === void 0 ? void 0 : _f.disabled)
                                .darken(0.3)
                                .toString(),
                        },
                        isDisabled && disabledTextStyle,
                        isDisabled && isSelected && disabledSelectedTextStyle,
                    ]) }, button))))));
    })));
};
exports.ButtonGroup = ButtonGroup;
var styles = react_native_1.StyleSheet.create({
    button: {
        flex: 1,
    },
    textContainer: {
        flex: 1,
        justifyContent: 'center',
        alignItems: 'center',
    },
    container: {
        marginHorizontal: 10,
        marginVertical: 5,
        borderColor: '#e3e3e3',
        borderWidth: 1,
        flexDirection: 'row',
        borderRadius: 3,
        overflow: 'hidden',
        backgroundColor: '#fff',
        height: 40,
    },
    verticalContainer: {
        flexDirection: 'column',
        height: null,
    },
    verticalComponent: {
        height: 40,
    },
    disabled: {
        backgroundColor: 'transparent',
    },
});
exports.ButtonGroup.displayName = 'ButtonGroup';
var hasElementKey = function (button) {
    return (typeof button === 'object' && Boolean(button.element));
};
