"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Divider = void 0;
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var helpers_1 = require("../helpers");
var Divider = function (_a) {
    var color = _a.color, _b = _a.inset, inset = _b === void 0 ? false : _b, _c = _a.insetType, insetType = _c === void 0 ? 'left' : _c, _d = _a.orientation, orientation = _d === void 0 ? 'horizontal' : _d, style = _a.style, subHeader = _a.subHeader, subHeaderStyle = _a.subHeaderStyle, width = _a.width, rest = __rest(_a, ["color", "inset", "insetType", "orientation", "style", "subHeader", "subHeaderStyle", "width"]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_native_1.View, __assign({ testID: "RNE__Divider", style: react_native_1.StyleSheet.flatten([
                styles.divider,
                style,
                inset &&
                    (insetType === 'left'
                        ? styles.leftInset
                        : insetType === 'right'
                            ? styles.rightInset
                            : __assign(__assign({}, styles.leftInset), styles.rightInset)),
                orientation === 'vertical' && styles.vertical,
                width &&
                    (orientation === 'horizontal'
                        ? { borderBottomWidth: width }
                        : { borderRightWidth: width }),
                color &&
                    (orientation === 'horizontal'
                        ? { borderBottomColor: color }
                        : { borderRightColor: color }),
            ]) }, rest)),
        subHeader && orientation === 'horizontal' ? (react_1.default.createElement(react_native_1.Text, { style: react_native_1.StyleSheet.flatten([
                styles.subHeader,
                subHeaderStyle,
                inset && styles.leftInset,
            ]) }, subHeader)) : null));
};
exports.Divider = Divider;
var styles = react_native_1.StyleSheet.create({
    divider: {
        borderBottomWidth: react_native_1.StyleSheet.hairlineWidth,
        borderBottomColor: (_a = helpers_1.defaultTheme === null || helpers_1.defaultTheme === void 0 ? void 0 : helpers_1.defaultTheme.colors) === null || _a === void 0 ? void 0 : _a.divider,
    },
    leftInset: {
        marginLeft: 72,
    },
    rightInset: {
        marginRight: 72,
    },
    vertical: {
        borderRightWidth: react_native_1.StyleSheet.hairlineWidth,
        borderRightColor: (_b = helpers_1.defaultTheme === null || helpers_1.defaultTheme === void 0 ? void 0 : helpers_1.defaultTheme.colors) === null || _b === void 0 ? void 0 : _b.divider,
        height: 'auto',
        alignSelf: 'stretch',
    },
    subHeader: {
        includeFontPadding: false,
    },
});
exports.Divider.displayName = 'Divider';
