"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListItemBase = void 0;
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var PadView_1 = require("./components/PadView");
var helpers_1 = require("../helpers");
var ListItemBase = function (props) {
    var _a, _b;
    var containerStyle = props.containerStyle, onPress = props.onPress, onLongPress = props.onLongPress, _c = props.Component, Component = _c === void 0 ? onPress || onLongPress ? react_native_1.Pressable : react_native_1.View : _c, disabled = props.disabled, disabledStyle = props.disabledStyle, bottomDivider = props.bottomDivider, topDivider = props.topDivider, _d = props.pad, pad = _d === void 0 ? 16 : _d, linearGradientProps = props.linearGradientProps, _e = props.ViewComponent, ViewComponent = _e === void 0 ? react_native_1.View : _e, _f = props.theme, theme = _f === void 0 ? helpers_1.defaultTheme : _f, children = props.children, rest = __rest(props, ["containerStyle", "onPress", "onLongPress", "Component", "disabled", "disabledStyle", "bottomDivider", "topDivider", "pad", "linearGradientProps", "ViewComponent", "theme", "children"]);
    if (props.linearGradientProps && !props.ViewComponent) {
        console.warn("You need to pass a ViewComponent to use linearGradientProps !\nExample: ViewComponent={require('react-native-linear-gradient')}");
    }
    return (react_1.default.createElement(Component, __assign({}, rest, { onPress: onPress, onLongPress: onLongPress, disabled: disabled }),
        react_1.default.createElement(PadView_1.PadView, __assign({ Component: ViewComponent }, linearGradientProps, { style: react_native_1.StyleSheet.flatten([
                __assign(__assign({}, react_native_1.Platform.select({
                    ios: {
                        padding: 14,
                    },
                    default: {
                        padding: 16,
                    },
                })), { flexDirection: 'row', alignItems: 'center', backgroundColor: (_a = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _a === void 0 ? void 0 : _a.background, borderColor: (_b = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _b === void 0 ? void 0 : _b.divider }),
                topDivider && { borderTopWidth: react_native_1.StyleSheet.hairlineWidth },
                bottomDivider && { borderBottomWidth: react_native_1.StyleSheet.hairlineWidth },
                containerStyle,
                disabled && disabledStyle,
            ]), pad: pad }), children)));
};
exports.ListItemBase = ListItemBase;
exports.ListItemBase.displayName = 'ListItem';
