"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchBarAndroid = void 0;
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var helpers_1 = require("../helpers");
var Input_1 = require("../Input");
var Icon_1 = require("../Icon");
var defaultSearchIcon = function (theme) {
    var _a, _b, _c;
    return ({
        type: 'material',
        size: 25,
        color: (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _a === void 0 ? void 0 : _a.platform) === null || _b === void 0 ? void 0 : _b.android) === null || _c === void 0 ? void 0 : _c.grey,
        name: 'search',
    });
};
var defaultCancelIcon = function (theme) {
    var _a, _b, _c;
    return ({
        type: 'material',
        size: 25,
        color: (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _a === void 0 ? void 0 : _a.platform) === null || _b === void 0 ? void 0 : _b.android) === null || _c === void 0 ? void 0 : _c.grey,
        name: 'arrow-back',
    });
};
var defaultClearIcon = function (theme) {
    var _a, _b, _c;
    return ({
        type: 'material',
        size: 25,
        color: (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _a === void 0 ? void 0 : _a.platform) === null || _b === void 0 ? void 0 : _b.android) === null || _c === void 0 ? void 0 : _c.grey,
        name: 'clear',
    });
};
var SearchBarAndroid = (function (_super) {
    __extends(SearchBarAndroid, _super);
    function SearchBarAndroid(props) {
        var _this = _super.call(this, props) || this;
        _this.focus = function () {
            _this.input.focus();
        };
        _this.blur = function () {
            _this.input.blur();
        };
        _this.clear = function () {
            _this.input.clear();
            _this.onChangeText('');
            _this.props.onClear();
        };
        _this.cancel = function () {
            _this.blur();
            _this.props.onCancel();
        };
        _this.onFocus = function (event) {
            _this.props.onFocus(event);
            _this.setState({
                hasFocus: true,
                isEmpty: _this.props.value === '',
            });
        };
        _this.onBlur = function (event) {
            _this.props.onBlur(event);
            _this.setState({ hasFocus: false });
        };
        _this.onChangeText = function (text) {
            _this.props.onChangeText(text);
            _this.setState({ isEmpty: text === '' });
        };
        _this._keyboardDidHide = function () {
            var _a, _b;
            _this.blur();
            (_b = (_a = _this.props).onKeyboardHide) === null || _b === void 0 ? void 0 : _b.call(_a);
        };
        var _a = props.value, value = _a === void 0 ? '' : _a;
        _this.state = {
            hasFocus: false,
            isEmpty: value ? value === '' : true,
        };
        if (_this.props.onKeyboardHide) {
            _this.keyboardListener = react_native_1.Keyboard.addListener('keyboardDidHide', _this._keyboardDidHide);
        }
        return _this;
    }
    SearchBarAndroid.prototype.componentWillUnmount = function () {
        if (this.keyboardListener) {
            this.keyboardListener.remove();
        }
    };
    SearchBarAndroid.prototype.render = function () {
        var _this = this;
        var _a;
        var _b = this.props, _c = _b.theme, theme = _c === void 0 ? helpers_1.defaultTheme : _c, _d = _b.clearIcon, clearIcon = _d === void 0 ? { name: 'clear' } : _d, containerStyle = _b.containerStyle, leftIconContainerStyle = _b.leftIconContainerStyle, rightIconContainerStyle = _b.rightIconContainerStyle, inputContainerStyle = _b.inputContainerStyle, inputStyle = _b.inputStyle, _e = _b.searchIcon, searchIcon = _e === void 0 ? { name: 'search' } : _e, _f = _b.cancelIcon, cancelIcon = _f === void 0 ? { name: 'arrow-back' } : _f, _g = _b.showLoading, showLoading = _g === void 0 ? false : _g, _h = _b.loadingProps, loadingProps = _h === void 0 ? {} : _h, attributes = __rest(_b, ["theme", "clearIcon", "containerStyle", "leftIconContainerStyle", "rightIconContainerStyle", "inputContainerStyle", "inputStyle", "searchIcon", "cancelIcon", "showLoading", "loadingProps"]);
        var _j = this.state, hasFocus = _j.hasFocus, isEmpty = _j.isEmpty;
        var loadingStyle = loadingProps.style, otherLoadingProps = __rest(loadingProps, ["style"]);
        return (react_1.default.createElement(react_native_1.View, { testID: "RNE__SearchBar-wrapper", style: react_native_1.StyleSheet.flatten([
                {
                    backgroundColor: (_a = theme === null || theme === void 0 ? void 0 : theme.colors) === null || _a === void 0 ? void 0 : _a.background,
                    paddingTop: 8,
                    paddingBottom: 8,
                },
                containerStyle,
            ]) },
            react_1.default.createElement(Input_1.Input, __assign({ testID: "RNE__SearchBar", renderErrorMessage: false }, attributes, { onFocus: this.onFocus, onBlur: this.onBlur, onChangeText: this.onChangeText, ref: function (input) {
                    _this.input = input;
                }, containerStyle: { paddingHorizontal: 0 }, inputStyle: react_native_1.StyleSheet.flatten([styles.input, inputStyle]), inputContainerStyle: react_native_1.StyleSheet.flatten([
                    styles.inputContainer,
                    inputContainerStyle,
                ]), leftIcon: hasFocus
                    ? (0, helpers_1.renderNode)(Icon_1.Icon, cancelIcon, __assign(__assign({}, defaultCancelIcon(theme)), { onPress: this.cancel }))
                    : (0, helpers_1.renderNode)(Icon_1.Icon, searchIcon, defaultSearchIcon(theme)), leftIconContainerStyle: react_native_1.StyleSheet.flatten([
                    styles.leftIconContainerStyle,
                    leftIconContainerStyle,
                ]), rightIcon: react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row' } },
                    showLoading && (react_1.default.createElement(react_native_1.ActivityIndicator, __assign({ key: "loading", style: react_native_1.StyleSheet.flatten([{ marginRight: 5 }, loadingStyle]) }, otherLoadingProps))),
                    !isEmpty &&
                        (0, helpers_1.renderNode)(Icon_1.Icon, clearIcon, __assign(__assign({}, defaultClearIcon(theme)), { key: 'cancel', onPress: this.clear }))), rightIconContainerStyle: react_native_1.StyleSheet.flatten([
                    styles.rightIconContainerStyle,
                    rightIconContainerStyle,
                ]) }))));
    };
    SearchBarAndroid.defaultProps = {
        onClear: function () { return null; },
        onCancel: function () { return null; },
        onFocus: function () { return null; },
        onBlur: function () { return null; },
        onChangeText: function () { return null; },
    };
    return SearchBarAndroid;
}(react_1.Component));
exports.SearchBarAndroid = SearchBarAndroid;
var styles = react_native_1.StyleSheet.create({
    input: {
        marginLeft: 24,
        marginRight: 8,
    },
    inputContainer: {
        borderBottomWidth: 0,
        width: '100%',
    },
    rightIconContainerStyle: {
        marginRight: 8,
    },
    leftIconContainerStyle: {
        marginLeft: 8,
    },
});
