"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SliderThumb = void 0;
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var THUMB_SIZE = 40;
var SliderThumb = function (_a) {
    var _b;
    var Component = _a.Component, isVisible = _a.isVisible, onLayout = _a.onLayout, style = _a.style, start = _a.start, color = _a.color, vertical = _a.vertical, props = __rest(_a, ["Component", "isVisible", "onLayout", "style", "start", "color", "vertical"]);
    var ThumbComponent = Component || react_native_1.Animated.View;
    var axis = vertical ? 'translateY' : 'translateX';
    var thumbPosition = [(_b = {}, _b[axis] = start, _b)];
    var styleTransform = (style && style.transform) || [];
    var visibleStyle = isVisible ? {} : { height: 0, width: 0 };
    return (react_1.default.createElement(ThumbComponent, __assign({ testID: "RNE__Slider_Thumb", onLayout: onLayout, style: react_native_1.StyleSheet.flatten([
            __assign({ backgroundColor: color, transform: __spreadArray(__spreadArray([], thumbPosition, true), styleTransform, true) }, visibleStyle),
            styles.thumb,
            style,
        ]) }, props)));
};
exports.SliderThumb = SliderThumb;
var styles = react_native_1.StyleSheet.create({
    thumb: {
        position: 'absolute',
        width: THUMB_SIZE,
        height: THUMB_SIZE,
        borderRadius: THUMB_SIZE / 2,
    },
});
