"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpeedDialAction = void 0;
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var index_1 = require("../FAB/index");
var SpeedDialAction = function (_a) {
    var title = _a.title, titleStyle = _a.titleStyle, placement = _a.placement, labelPressable = _a.labelPressable, onPress = _a.onPress, actionProps = __rest(_a, ["title", "titleStyle", "placement", "labelPressable", "onPress"]);
    return (react_1.default.createElement(react_native_1.Pressable, { onPress: labelPressable ? onPress : undefined, style: [
            styles.action,
            placement === 'left' && {
                flexDirection: 'row-reverse',
            },
        ] },
        title && react_1.default.createElement(react_native_1.Text, { style: [styles.title, titleStyle] }, title),
        react_1.default.createElement(index_1.FAB, __assign({}, actionProps, { onPress: onPress, size: "small", style: [actionProps.style] }))));
};
exports.SpeedDialAction = SpeedDialAction;
var styles = react_native_1.StyleSheet.create({
    title: {
        backgroundColor: 'white',
        color: 'black',
        borderRadius: 5,
        paddingHorizontal: 12,
        paddingVertical: 6,
        marginVertical: 8,
        marginHorizontal: 16,
        elevation: 2,
    },
    action: {
        marginBottom: 16,
        marginRight: 24,
        flexDirection: 'row',
        justifyContent: 'flex-end',
        alignItems: 'center',
    },
});
exports.SpeedDialAction.displayName = 'SpeedDial.Action';
