"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeaturedTile = void 0;
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var helpers_1 = require("../../helpers");
var helpers_2 = require("../../helpers");
var Text_1 = require("../../Text");
var Icon_1 = require("../../Icon");
var renderText = function (content, defaultProps, style) {
    return (0, helpers_2.renderNode)(Text_1.Text, content, __assign(__assign({}, defaultProps), { style: react_native_1.StyleSheet.flatten([style, defaultProps && defaultProps.style]) }));
};
var FeaturedTile = function (_a) {
    var title = _a.title, icon = _a.icon, caption = _a.caption, imageSrc = _a.imageSrc, containerStyle = _a.containerStyle, imageContainerStyle = _a.imageContainerStyle, overlayContainerStyle = _a.overlayContainerStyle, iconContainerStyle = _a.iconContainerStyle, titleStyle = _a.titleStyle, captionStyle = _a.captionStyle, _b = _a.ImageComponent, ImageComponent = _b === void 0 ? helpers_1.BackgroundImage : _b, _c = _a.imageProps, imageProps = _c === void 0 ? {} : _c, _d = _a.width, width = _d === void 0 ? react_native_1.Dimensions.get('window').width : _d, _e = _a.height, height = _e === void 0 ? width * 0.8 : _e, attributes = __rest(_a, ["title", "icon", "caption", "imageSrc", "containerStyle", "imageContainerStyle", "overlayContainerStyle", "iconContainerStyle", "titleStyle", "captionStyle", "ImageComponent", "imageProps", "width", "height"]);
    return (react_1.default.createElement(react_native_1.Pressable, __assign({}, attributes, { style: react_native_1.StyleSheet.flatten([
            { width: width, height: height },
            containerStyle && containerStyle,
        ]) }),
        react_1.default.createElement(ImageComponent, __assign({ resizeMode: "cover" }, imageProps, { source: imageSrc, style: react_native_1.StyleSheet.flatten([
                { width: width, height: height },
                styles.imageContainer,
                imageContainerStyle && imageContainerStyle,
            ]) }),
            react_1.default.createElement(react_native_1.View, { style: react_native_1.StyleSheet.flatten([
                    styles.overlayContainer,
                    overlayContainerStyle && overlayContainerStyle,
                ]) },
                react_1.default.createElement(react_native_1.View, { style: react_native_1.StyleSheet.flatten([
                        styles.iconContainer,
                        iconContainerStyle && iconContainerStyle,
                    ]) }, icon && react_1.default.createElement(Icon_1.Icon, __assign({}, icon))),
                react_1.default.createElement(Text_1.Text, { testID: "featuredTileTitle", h4: !titleStyle || !('fontSize' in titleStyle), style: react_native_1.StyleSheet.flatten([styles.text, titleStyle && titleStyle]) }, title),
                renderText(caption, { style: captionStyle }, styles.text)))));
};
exports.FeaturedTile = FeaturedTile;
var styles = react_native_1.StyleSheet.create({
    imageContainer: {
        alignItems: 'center',
        justifyContent: 'center',
    },
    overlayContainer: {
        flex: 1,
        alignItems: 'center',
        alignSelf: 'stretch',
        justifyContent: 'center',
        paddingLeft: 25,
        paddingRight: 25,
        paddingTop: 45,
        paddingBottom: 40,
        position: 'absolute',
        top: 0,
        left: 0,
        right: 0,
        bottom: 0,
    },
    text: {
        color: '#ffffff',
        backgroundColor: 'rgba(0,0,0,0)',
        marginBottom: 15,
        textAlign: 'center',
    },
    iconContainer: {
        justifyContent: 'center',
        alignItems: 'center',
        alignSelf: 'center',
    },
});
